#include "banana.h"
#include "dirty.h"
#include "spam.h"
#include "game.h"

BANANA *banana_list;

BANANA *add_banana(int x, int y) {
	BANANA *iter, *b;

	b = (BANANA*) malloc(sizeof(BANANA));
	b->x = x;
	b->y = y;
	b->r = rand() % 0xffffff;
	b->next = NULL;

	if (!banana_list) {
		banana_list = b;
	}
	else {
		for (iter = banana_list; iter->next; iter = iter->next) ;

		iter->next = b;
	}

	return b;
}

BANANA *delete_banana(BANANA *b) {
	BANANA *iter;

	if (b = banana_list) {
		banana_list = b->next;
		free(b);
		return banana_list;
	}
	else {
		for (iter = banana_list; iter->next != b; iter = iter->next) ;

		iter->next = b->next;
		free(b);
		return iter->next;
	}
}

void clear_bananas(void) {
	BANANA *iter = banana_list;
	while (iter) {
		iter = delete_banana(iter);
	}
}

void draw_bananas(BITMAP *bmp) {
	BANANA *iter;
	for (iter = banana_list; iter; iter = iter->next) {
		int x = iter->x;
		int y = iter->y;

		rotate_sprite(bmp, banana, x, y, iter->r);
		//draw_sprite(bmp, banana, x, y);
		dirty_rectangle(x, y, banana->w, banana->h);
	}
}

void process_bananas(void) {
	BANANA *iter = banana_list;
	while (iter) {
		iter->y -= 6;
		iter->r += itofix(6);
		iter->r &= 0xFFFFFF;

		if (iter->y < -banana->h) {
			iter = delete_banana(iter);
			goto banana_updated;
		}
		else {
			if (spam_collide(iter->x, iter->y)) {
				spam_hit();
				iter = delete_banana(iter);
				play_sample((SAMPLE*)data[HIT1_WAV + rand() % 3].dat, 255, 128, 1000, 0);
				goto banana_updated;
			}
		}

		iter = iter->next;

banana_updated:;
	}
}
