#include "spamtac.h"
#include "title.h"

bool title_screen(void) {
	bool changed = true, clicked = false, snapshot = true;

	mouse_b = 0;

	clear_keybuf();
	set_palette((RGB*)data[TITLE_PAL].dat);
	BITMAP *item, *bmp;
	bmp = create_bitmap(800, 600);
	clear_bitmap(bmp);

	// Logo
	item = (BITMAP*)data[TITLE_LOGO].dat;
	blit(item, bmp, 0, 0, 400-item->w/2, 20, item->w, item->h);

	// Player buttons
	// y = 274
	item = (BITMAP*)data[TITLE_1PLAYER_BMP].dat;
	blit(item, bmp, 0, 0, 42, 274, item->w, item->h);
	item = (BITMAP*)data[TITLE_2PLAYER_BMP].dat;
	blit(item, bmp, 0, 0, 242, 274, item->w, item->h);
	item = (BITMAP*)data[TITLE_3PLAYER_BMP].dat;
	blit(item, bmp, 0, 0, 442, 274, item->w, item->h);
	item = (BITMAP*)data[TITLE_4PLAYER_BMP].dat;
	blit(item, bmp, 0, 0, 642, 274, item->w, item->h);

	// Time buttons
	// y = 387
	item = (BITMAP*)data[TITLE_30SEC_BMP].dat;
	blit(item, bmp, 0, 0, 22, 387, item->w, item->h);
	item = (BITMAP*)data[TITLE_1MIN_BMP].dat;
	blit(item, bmp, 0, 0, 182, 387, item->w, item->h);
	item = (BITMAP*)data[TITLE_2MIN_BMP].dat;
	blit(item, bmp, 0, 0, 342, 387, item->w, item->h);
	item = (BITMAP*)data[TITLE_3MIN_BMP].dat;
	blit(item, bmp, 0, 0, 502, 387, item->w, item->h);
	item = (BITMAP*)data[TITLE_5MIN_BMP].dat;
	blit(item, bmp, 0, 0, 662, 387, item->w, item->h);

	// Command buttons
	// y = 489
	item = (BITMAP*)data[TITLE_PLAY_BMP].dat;
	blit(item, bmp, 0, 0, 142, 489, item->w, item->h);
	item = (BITMAP*)data[TITLE_QUIT_BMP].dat;
	blit(item, bmp, 0, 0, 542, 489, item->w, item->h);

	play_sample((SAMPLE*)data[SPAMBANANA_WAV].dat, 255, 128, 1000, 0);
	num_players = 2;
	time_limit = TIME_3MIN;
	item = create_bitmap(800, 600);
	while (1) {
		if (keypressed() && (readkey() >> 8) == KEY_ESC) {
			destroy_bitmap(item);
			destroy_bitmap(bmp);
			return false;
		}
		if (mouse_b & 1 && !clicked) {
			clicked = true;
			// Players change
			if (mouse_y > 274 && mouse_y < 320) {
				if (mouse_x > 42 && mouse_x < (42+117)) {
					num_players = 1;
					changed = true;
				}
				if (mouse_x > 242 && mouse_x < (242+117)) {
					num_players = 2;
					changed = true;
				}
				if (mouse_x > 442 && mouse_x < (442+117)) {
					num_players = 3;
					changed = true;
				}
				if (mouse_x > 642 && mouse_x < (642+117)) {
					num_players = 4;
					changed = true;
				}
			}

			// Time change
			if (mouse_y > 387 && mouse_y < 433) {
				if (mouse_x > 22 && mouse_x < (22+117)) {
					time_limit = TIME_30SEC;
					changed = true;
				}
				if (mouse_x > 182 && mouse_x < (182+117)) {
					time_limit = TIME_1MIN;
					changed = true;
				}
				if (mouse_x > 342 && mouse_x < (342+117)) {
					time_limit = TIME_2MIN;
					changed = true;
				}
				if (mouse_x > 502 && mouse_x < (502+117)) {
					time_limit = TIME_3MIN;
					changed = true;
				}
				if (mouse_x > 662 && mouse_x < (662+117)) {
					time_limit = TIME_5MIN;
					changed = true;
				}
			}

			// Play button
			if (mouse_x > 142 && mouse_x < (142+117) && mouse_y > 489 && mouse_y < 535) {
				destroy_bitmap(item);
				destroy_bitmap(bmp);
				return true;
			}

			// Quit button
			if (mouse_x > 542 && mouse_x < (542+117) && mouse_y > 489 && mouse_y < 535) {
				destroy_bitmap(item);
				destroy_bitmap(bmp);
				return false;
			}
		}

		if (clicked && !(mouse_b & 1)) {
			clicked = false;
		}

		if (changed) {
			blit(bmp, item, 0, 0, 0, 0, 800, 600);
			switch(num_players) {
				case 1:
					rect(item, 42, 274, 42+117, 320, 1);
					break;
				case 2:
					rect(item, 242, 274, 242+117, 320, 1);
					break;
				case 3:
					rect(item, 442, 274, 442+117, 320, 1);
					break;
				case 4:
					rect(item, 642, 274, 642+117, 320, 1);
					break;
			}

			switch (time_limit) {
				case TIME_30SEC:
					rect(item, 22, 387, 22+117, 433, 1);
					break;
				case TIME_1MIN:
					rect(item, 182, 387, 182+117, 433, 1);
					break;
				case TIME_2MIN:
					rect(item, 342, 387, 342+117, 433, 1);
					break;
				case TIME_3MIN:
					rect(item, 502, 387, 502+117, 433, 1);
					break;
				case TIME_5MIN:
					rect(item, 662, 387, 662+117, 433, 1);
					break;
			}

			scare_mouse();
			blit(item, screen, 0, 0, 0, 0, 800, 600);
			unscare_mouse();
			changed = false; // Prevents mouse flicker
		}
	}
}
